NayaKhabar/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from django.views.generic import TemplateView

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include("news.urls", namespace="news")),
    path('', include("accounts.urls", namespace="accounts")),

]
if settings.DEBUG: 
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

accounts/urls.py
from django.urls import path
from django.views.generic import TemplateView
from django.contrib.auth import views as auth_views

from . import views


app_name = "accounts"
urlpatterns = [
    path('login/', auth_views.LoginView.as_view(template_name="accounts/login.html"), name="login"),
    # path('login/', views.LoginView.as_view(), name="login"),
    # path('logout/', TemplateView.as_view(template_name="accounts/login.html"), name="logout"),
    path('logout/', auth_views.LogoutView.as_view(), name="logout"),
    path('register/', TemplateView.as_view(template_name="accounts/login.html"), name="register"),
]

news/urls.py
from django.urls import path
from . import views

app_name = "news"
urlpatterns = [
    path('', views.ArticleListView.as_view(), name='news_home'),
    path('articles/<int:pk>/', views.ArticleDetailView.as_view(), name="article_details"),
    path('articles/create_article/', views.ArticleCreateForm.as_view(), name="create_article"),
    path('articles/<int:pk>/update/', views.ArticleUpdateView.as_view(), name="update_article"),
    path('articles/<int:pk>/delete/', views.ArticleDeleteView.as_view(), name="delete_article"),
]

accounts/models.py
from django.db import models
from django.contrib.auth.models import AbstractUser

# Create your models here.
class User(AbstractUser):
    email       = models.EmailField(unique=True)
    nickname    = models.CharField(max_length=50, null=True, blank=True)
    is_subscriber = models.BooleanField(default=False)

    def __str__(self):
        return self.email
    

class Profile(models.Model):
    user        = models.OneToOneField(User, on_delete=models.CASCADE)
    bio         = models.TextField(max_length=500, blank=True)
    address     = models.CharField("Permanent Address", max_length=100, null=True, blank=True)
    birth_date  = models.DateField(auto_now=False, auto_now_add=False, null=True, blank=True)
    position    = models.CharField(max_length=100, null=True, blank=True)

    def __str__(self):
        if self.user:
            return self.user.username
        return "User Profile"
    

news/models.py
from django.db import models
from django.shortcuts import reverse

# from accounts.models import User

# Create your models here.
class Article(models.Model):
    title = models.CharField(max_length=200)
    content = models.TextField()
    publisher = models.ForeignKey("accounts.User", on_delete=models.CASCADE)
    created_at = models.DateTimeField(auto_now_add=True)
    is_published = models.BooleanField(default=False)
    updated_at = models.DateTimeField(auto_now=True)
    updated_by = models.ForeignKey("accounts.User",related_name="updater", on_delete=models.CASCADE, null=True, blank=True)

    def get_absolute_url(self):
        return reverse("news:article_details", kwargs={"pk": self.pk})
    
    def __str__(self):
        return self.title[:20]
    

class ArticleImages(models.Model):
    article = models.ForeignKey(Article, on_delete=models.CASCADE)
    image = models.ImageField(upload_to='articles/')
    caption = models.TextField(null=True, blank=True)

    def __str__(self):
        return self.article.title[:20]
    

accounts/forms.py
from django import forms

from .models import User

class LoginForm(forms.ModelForm):
    class Meta:
        model = User
        fields = ["username","password"]

class RegisterForm(forms.ModelForm):
    class Meta:
        model = User
        fields = "__all__"

news/forms.py
from django import forms

from .models import Article, ArticleImages

class ArticleForm(forms.ModelForm):
    class Meta:
        fields = "__all__"


class ArticleImagesForm(forms.ModelForm):
    class Meta:
        fields = "__all__"

accounts/views.py
from django.shortcuts import render, redirect
from django.views import View
from django.contrib.auth import authenticate, login, logout

from .forms import LoginForm, RegisterForm
# Create your views here.

class LoginView(View):
    form_class = LoginForm
    template_name = "accounts/login.html"
    
    def post(self, request, *args, **kwargs):
        form = self.form_class(request.POST)
        if form.is_valid():
            username = form.cleaned_data.get("username")
            password = form.cleaned_data.get("password")
            user = authenticate(request, username=username, password=password)
            if user is not None:
                login(request, user)
                return redirect("/")
        return render(self.request, self.template_name, {'form':form})

    def get(self, request, *args, **kwargs):
        form = self.form_class()
        return render(self.request, self.template_name, {'form':form})


# def logout(request):
#     if request.method == "POST":
#         logout(request)

news/views.py
from django.shortcuts import render
from django.urls import reverse_lazy
from django.views.generic import ListView, DetailView
from django.views.generic.edit import CreateView, DeleteView, UpdateView

#decorators
from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator

from .models import Article, ArticleImages

# Create your views here.

class ArticleListView(ListView):
    model = Article
    template_name = "news/home.html"
    context_object_name = "articles"

class ArticleDetailView(DetailView):
    model = Article
    context_object_name = "article"
    template_name = "news/article_detail.html"

class ArticleCreateForm(CreateView):
    model = Article
    fields = ["title","content"]

    def form_valid(self, form):
        form.instance.publisher = self.request.user
        form.instance.updated_by = self.request.user
        return super().form_valid(form)

@method_decorator(login_required, name='dispatch')
class ArticleUpdateView(UpdateView):
    model = Article
    fields = ["title","content"]

    def form_valid(self, form):
        form.instance.updater = self.request.user
        return super().form_valid(form)

@method_decorator(login_required, name='dispatch')
class ArticleDeleteView(DeleteView):
    model = Article
    success_url = reverse_lazy("news:news_home")

accounts/templates/accounts/login.html
<h1>login form</h1>
<form method="post">
    {% csrf_token %}
    <table>
        {{form.as_table}}
    </table>
    <input type="submit" value="Login">
</form>

accounts/templates/base/base.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">

    <title>{% block title %}
        {% endblock title %}</title>

    {% block head %}
    {% endblock head %}

</head>

<body>

    <nav>
        <a href="{% url "news:create_article" %}">Publish new article</a> |
        <a href="{% url "news:news_home" %}">All News</a> |
        {% if request.user.is_authenticated %}
        <a href="{% url "accounts:logout" %}">Logout</a> |
        {% else %}
        <a href="{% url "accounts:login" %}">Login</a> |
        <a href="{% url "accounts:register" %}">Register</a> |
        {% endif %}
        
    </nav>
    <hr>
    {% block body %}
    {% endblock body %}

    {% block script %}
    {% endblock script %}

</body>

</html>

news/templates/news/article_confirm_delete.html
<form method="post">{% csrf_token %}
    <p>Are you sure you want to delete "{{ article }}"?</p>
    <input type="submit" value="Confirm">
</form>

news/templates/news/article_detail.html
{% extends 'base/base.html' %}
{% block title %}{{article.title|truncatewords:5}}
{% endblock title %}
{% block body %}

<h2>{{article.title}}</h2>
<p>Published by : {{article.publisher}} - {{article.created_at}}</p>
<br>
{% for image in article.articleimages_set.all %}
    <img src="{{image.image.url}}" alt="" height="200" width="200">
{% endfor %}
<p>{{article.content}}</p>

<a href="{% url "news:update_article" article.id %}">Edit Article</a>

<a href="{% url "news:delete_article" article.id %}">Delete Article</a>


{% endblock body %}

news/templates/news/article_form.html
{% extends 'base/base.html' %}

{% block title %}Article Form
{% endblock title %}

{% block body %}
<form method="POST">
    {% csrf_token %}
    <table>
    {{form.as_table}}
    </table>
    <input type="submit" value="Submit">
</form>
{% endblock body %}

news/templates/news/home.html
{% extends 'base/base.html' %}

{% block title %}Naya News | Hot News
{% endblock title %}

{% block body %}

{% for article in articles %}
    <h3>{{article.title}}</h3>
    <p><small>{{article.created_at|timesince:article.updated_at}} ago</small></p>
    <p>{{article.content|truncatewords:5}}<a href="{{article.get_absolute_url}}">more</a></p>
    
    <hr>

{% endfor %}

{% endblock body %}